=== src/interfaces/octave_modular/CMakeLists.txt ===
include(CommonModularInterface)
include_directories(${OCTAVE_INCLUDE_DIRS})

GENERATE_MODULAR_TARGET(octave ${CMAKE_CURRENT_SOURCE_DIR} ${OCTAVE_LIBRARIES})
set_target_properties(octave_modular PROPERTIES PREFIX "")
set_target_properties(octave_modular PROPERTIES SUFFIX ".oct")

SET(OCTAVE_MODULAR_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)
install (TARGETS octave_modular
    DESTINATION ${OCTAVE_OCT_LOCAL_API_FILE_DIR}/shogun
	COMPONENT octave)

set(CPACK_COMPONENT_OCTAVE_DISPLAY_NAME "OCTAVE interface" PARENT_SCOPE)
set(CPACK_COMPONENT_OCTAVE_DESCRIPTION "OCTAVE modular interface of Shogun" PARENT_SCOPE)
set(CPACK_COMPONENT_OCTAVE_GROUP "Runtime" PARENT_SCOPE)
set(CPACK_COMPONENT_OCTAVE_DEPENDS libraries PARENT_SCOPE)
SET(CPACK_COMPONENTS_ALL ${CPACK_COMPONENTS_ALL} octave PARENT_SCOPE)
