=== debian/changelog ===
shogun (3.2.0-7.5) unstable; urgency=medium

  * Non-maintainer upload
  * Drop build-dependency on libatlas-dev (Closes: #871716)

 -- Graham Inggs <ginggs@debian.org>  Tue, 19 Sep 2017 14:57:41 +0000

shogun (3.2.0-7.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch from Graham Inggs to fix Eigen 3.3 FTBFS. (Closes: #809290)

 -- Adrian Bunk <bunk@debian.org>  Sun, 15 Jan 2017 01:01:38 +0200

shogun (3.2.0-7.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Add missing python to Build-Depends. (Closes: #765131)

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 21 Oct 2014 05:23:58 +0200

shogun (3.2.0-7.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-Depends: clang instead of clang-3.4 (closes: #760120)
    /usr/bin/clang is now provided by clang since co-installability of
    clang-* packages.

 -- Gilles Filippini <pini@debian.org>  Sun, 31 Aug 2014 18:11:41 +0200

shogun (3.2.0-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-Depends: libjson-c-dev instead of libjson-c2-dev | libjson0-dev
    (closes: #758009).

 -- Gilles Filippini <pini@debian.org>  Wed, 27 Aug 2014 10:33:25 +0200

shogun (3.2.0-7) unstable; urgency=low

  * Build depend on libjson-c2-dev instead of libjson-c-dev.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 11 Jul 2014 22:13:43 +0200

shogun (3.2.0-6) unstable; urgency=low

  * Attempt to use gcc on powerpc to workaround compile failure.

 -- Soeren Sonnenburg <sonne@debian.org>  Fri, 11 Jul 2014 21:42:24 +0200

shogun (3.2.0-5) unstable; urgency=low

  * Fix typo on i386 releases.

 -- Soeren Sonnenburg <sonne@debian.org>  Mon, 07 Jul 2014 17:29:40 +0200

shogun (3.2.0-4) unstable; urgency=low

  * Disable sse on i386 architectures to fix FTBS.
  * Add arc4random to build deps.

 -- Soeren Sonnenburg <sonne@debian.org>  Sun, 06 Jul 2014 04:18:46 +0200

shogun (3.2.0-3) unstable; urgency=low

  * Add build-dependency on colpack.

 -- Soeren Sonnenburg <sonne@debian.org>  Thu, 05 Jun 2014 07:59:38 +0200

shogun (3.2.0-2) unstable; urgency=low

  * Build depend on libjson-c-dev instead of libjson0-dev (Closes: #745013)

 -- Soeren Sonnenburg <sonne@debian.org>  Sat, 01 Mar 2014 21:27:42 +0100

shogun (3.2.0-1) unstable; urgency=low

  * New upstream version with mostly bugfixes
    - Enable atlas, cblas, libnlopt-dev, protobuf, libcurl, libbz2
    - Use clang to compile on mips, mipsel and powerpc
    - Update watch file.
    - Add script to remove copyrighted svmlight code from shogun (thanks
      Bjoern Esser).

 -- Soeren Sonnenburg <sonne@debian.org>  Sat, 01 Mar 2014 07:05:09 +0100
